(module srfi-130
  (string-cursor? string-cursor-start string-cursor-end
   string-cursor-prev string-cursor-next
   string-cursor-forward string-cursor-back
   string-cursor=? string-cursor<? string-cursor>?
   string-cursor<=? string-cursor>=? string-cursor>?
   string-cursor-diff string-cursor->index string-index->cursor

   string-null? string-every string-any

   string-tabulate string-unfold string-unfold-right
   string->list/cursors string->vector/cursors
   reverse-list->string string-join

   string-ref string-ref/cursor substring/cursors string-copy/cursors
   string-take string-drop string-take-right string-drop-right
   string-pad string-pad-right
   string-trim string-trim-right string-trim-both

   string-prefix-length string-suffix-length
   string-prefix? string-suffix?

   string-index string-index-right string-skip string-skip-right
   string-contains string-contains-right

   string-reverse string-concatenate string-concatenate-reverse
   string-fold string-fold-right string-for-each-cursor
   string-replicate string-count string-replace
   string-split string-filter string-remove)

  (import (except scheme
                  string-length string-ref string-set! make-string
                  string substring string->list list->string string-fill!
                  write-char read-char display)
          (only (chicken base) include error receive let-optionals*
                               case-lambda exact-integer? assert)
          (chicken module)
          (chicken platform)
          (chicken type)
          (except utf8
                  string-set! make-string string-fill!
                  write-char read-char display print print* ->string conc
                  string-chop string-split string-translate substring=?
                  substring-ci=? substring-index substring-index-ci
                  read-string write-string read-token)
          (only (srfi 1) last-pair)
          (except (utf8-srfi-13) string-index string-index-right string-skip
                                 string-skip-right)
          (prefix (only (utf8-srfi-13) string-index string-index-right)
                  srfi-13:)
          (only (srfi 141) euclidean-remainder))

  (register-feature! 'srfi-130)

  (include "r7rs-shim.scm")
  (include "srfi/130.body.scm")
)
